'#Reference {5B50E6F7-C8A1-46D4-955E-B6115F85A311}#1.0#0#C:\Program Files\filemaker_8\FileMaker Pro 8 Advanced\FileMaker Pro Advanced.exe#FileMaker Pro 7.0 Type Library
' FM8_GetSpectrum.bas for FilmStar DESIGN/MEASURE
' Copyright 2003-2005 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Sample program showing FilmStar-FileMaker 8 interface

' Get spectrum from FileMaker Pro container field
' FileMaker Pro database 'spectrum_8.fp7'

' 06.02.04...FM7 version
' 03.19.05...Move FileMaker check to ModFMCHeck.bas
' 10.09.05...FM8 version

' NOTE: If program fails to run, it may be necessary
'       to re-establish a reference to the FileMaker
'       Pro 7.0 Type Library (Edit...References)

'#Uses "FM_RunCheck.bas"

Option Explicit
DefLng i-N
DefSng a-H, O-Z

' ************ Change path as required ************
' Note: temp$ must be the same as Temp File field
Const temp$ = "c:\Winfilm\Course2\Database\temp.dx"

Const dbase$ = "Spectra.fp7"
' *************************************************

Public FMApp As FMPRO70Lib.Application
Public FMDocs As FMPRO70Lib.Documents
Public dbFile As FMPRO70Lib.Document

Const Title$ = "Get Spectrum"

Const Delay = .5    ' delay in seconds to avoid overrunning FileMaker

Sub Main
    FMRun
End Sub

Private Sub FMRun
    On Error GoTo MainErr
    If Not FMCheck(Title$) Then End
    Set FMApp = New FMPRO70Lib.Application
    DoEvents
    If FMApp.Visible = 0 Then
        FMApp.Quit ' remove process
        DoEvents
        Set FMApp = Nothing
        MsgBox "FileMaker Pro is not visible" , vbOkOnly + vbCritical, Title$
        End
    End If
    Set FMDocs = FMApp.Documents
    If FMDocs.Count > 0 Then
        Set dbFile = FMDocs.Active
        If InStr(LCase(dbFile.FullName), LCase(dbase$)) = 0 Then
            MsgBox "Active database must be " & dbase$, vbOkOnly + vbCritical, Title$
        Else
            DoFMTasks
        End If
    Else
        MsgBox "Database " & dbase$ & " is not open", vbOkOnly + vbCritical, Title$
    End If
MainExit:
    Set FMDocs = Nothing
    Set dbFile = Nothing
    Set FMApp = Nothing
    Busy False  ' just in case hourglass left
    Exit Sub
MainErr:
    MsgBox Err.Description, vbOkOnly + vbCritical, Title$
    GoTo MainExit
End Sub

Private Sub DoFMTasks
    dbFile.DoFMScript "Export Spectrum"   ' exports FM to temp$
    Wait Delay
    FileOpen temp$
    MainActivate
    AxesDraw
    Replot
End Sub

